## Script (Python) "batch_rows"
##Parameters=count=0, columns=4, rows=4
##

import ZTUtils
import math

request = container.REQUEST
RESPONSE =  request.RESPONSE
count=int(count)
columns=int(columns)
rows=int(rows)

images = context.thumbnails.viewable_images()
nrimg=len(images)

if (nrimg != 0):

# adapt columns and rows to number of images, if out of range

  if (columns < 1): columns = 1
  if (rows < 1): rows = 1

  if (columns > nrimg and rows < nrimg): 
    columns = nrimg
    rows = 1
  if (rows > nrimg and columns < nrimg):
    rows = nrimg
    columns = 1

  if (rows * columns > nrimg):
    for i in range(math.sqrt(nrimg)+1):
      if (i*i > nrimg): break
    rows = columns = i+1

  if (count < 0): count = 0
  if (count > nrimg): count = nrimg-(rows*columns)
 
  batch_rows = []
  batch_rows.append(ZTUtils.Batch(images,columns,count))

  for i in range(rows-1):
    if (batch_rows[i].next):
      batch_rows.append(batch_rows[i].next)
    else:
      break

  return batch_rows

else:

  return None
